function []=plotcircle(X,r,pl,label,col)
%[]=plotcircle(X,r,u,v,label,col);
% INPUTS :
%	X  : hypersphere centers (nxp)
%	r  : hyperspaeres radii  (nx1)
%	pl : representation axis (e.g. [1 2]);
%	label (optional) : object labelling
%	col (optional) : color of the plot (default 'b');
%
% See also MDSI, NMDSI

if nargin<3 error('PLOTCIRCLE requires at least 3 input arguments');end;

n=size(X,1);
u=pl(1);v=pl(2);
plot(X(:,u),X(:,v),'.');

if nargin>3 
	yadeslabels = 1;
else
	yadeslabels=0;
end;

if nargin<5
	col = 'b';
end;

hold on;
for i=1:n;circle([X(i,u) X(i,v)],r(i,:),col);end;

if yadeslabels
	for i=1:n,
	h=text(X(i,u),X(i,v),label(i,:));set(h,'FontSize',14);
	end;
	axis equal
else
	for i=1:n,
	h=text(X(i,u),X(i,v),num2str(i));set(h,'FontSize',14);
	end;
	axis equal;
end;


function [t]=circle(x,r,c)
% [t]=circle(x,r,c) plots a circle of radius r with center x. 
if nargin==2
	c = 'b';
end;

alpha = 0:.1:2*pi ;
y1 = r*cos(alpha)+x(1);
y2=r*sin(alpha)+x(2);
t=plot(y1,y2,c);
