function [S,dS] = stress(param,deltab,deltah,W,m,p);
% stress function, metric multidimensional scaling
% REQUIRES: tabdist

X=param(1:m*p);
X = reshape(X,m,p);
r = param(m*p+1:m*(p+1));

D = tabdist(X);

R1 = ones(m,1)*r';
R1=R1.^2;
D1 = D+R1+R1';
D2 = D-R1-R1';
DIAGZERO = ones(m,m)-diag(ones(m,1));
D1 = D1.*DIAGZERO ;
D2 = D2.*DIAGZERO ;
D2 = max(0,D2);
deltab=deltab.*W;
deltah=deltah.*W;
D1=D1.*W;
D2=D2.*W;
S = sum(sum((deltab-D2).^2))+sum(sum((deltah-D1).^2));

S=S/2;

dJ2rk = zeros(m,1);
dJ2xk = zeros(m,p);
dJ1rk = zeros(m,1);
dJ1xk = zeros(m,p);


for k=1:m;

	a = (D(k,:)+(r.*r)'+(r(k)^2)*ones(1,m));
	truc = (a-deltah(k,:))*r(k)*2;
	truc = W(k,:).*truc ;
	truc(k)=[];
	dJ2rk(k) = sum(truc);
	DD = D(k,:);
	DD(k)=[];
	truc2=(a-deltah(k,:));
	truc2 = W(k,:).*truc2;
	truc2(k)=[];
	truc2 = truc2./DD;
	diff = (X(k,:)'*ones(1,m))-X';
	diff(:,k)=[];
	truc3 = ones(p,1)*truc2 ;
	truc4 = truc3.*diff;
	dJ2xk(k,:)=sum(truc4,2)';

	b = D(k,:)-(r.*r)'-(r(k)^2)*ones(1,m);
	truc = (deltab(k,:)-max(0,b)).*((b==0)*0.5+(b>0));
	truc = W(k,:).*truc ;
	truc(k)=[];
	dJ1rk(k) = sum(truc)*r(k)*2;	
	DD = D(k,:);
	DD(k)=[];
	truc2 = (max(0,b)-deltab(k,:)).*((b==0)*0.5+(b>0));
	truc2 = W(k,:).*truc2;
	truc2(k)=[];
	truc2 = truc2./DD;	
	diff = (X(k,:)'*ones(1,m))-X';
	diff(:,k)=[];
	truc3 = ones(p,1)*truc2 ;
	truc4 = truc3.*diff;
	dJ1xk(k,:)=sum(truc4,2)';

end;

dJX = dJ1xk+dJ2xk;
dJR = dJ1rk+dJ2rk ;

dJX = reshape(dJX,m*p,1);

dS = [dJX;dJR];
dS=dS/2;
